Imports System
Imports System.Collections
Imports System.Configuration
Imports System.Windows.Forms
Imports AmazonWishList.AmazonWebServices

Public Class Form1

	'Dim AmazonKey As String = ConfigurationManager.AppSettings(Constants.ApplicationSettings.AmazonAccessKeyId)
	'Dim amazonPrime As AWSECommerceService = New AmazonWishList.AmazonWebServices.AWSECommerceService
	Dim giftList As ArrayList = New ArrayList
	Private Class ListItemsSimple

		Private _listItemId As String

		Private _title As String

		Private _url As String

		Private _height As Decimal

		Private _width As Decimal

		Private _length As Decimal

		Public Sub New(ByVal ListItemId As String, ByVal Title As String, ByVal Url As String, ByVal Height As Decimal, ByVal Width As Decimal, ByVal Length As Decimal)
			MyBase.New()
			_listItemId = ListItemId
			_title = Title
			_url = Url
			_height = Height
			_width = Width
			_length = Length
		End Sub

		Public ReadOnly Property ListItemId() As String
			Get
				Return _listItemId
			End Get
		End Property

		Public ReadOnly Property Title() As String
			Get
				Return _title
			End Get
		End Property

		Public ReadOnly Property Url() As String
			Get
				Return _url
			End Get
		End Property

		Public ReadOnly Property Height() As Decimal
			Get
				Return _height
			End Get
		End Property

		Public ReadOnly Property Width() As Decimal
			Get
				Return _width
			End Get
		End Property

		Public ReadOnly Property Length() As Decimal
			Get
				Return _length
			End Get
		End Property
	End Class

	Public Class Constants
		Public Class ApplicationSettings
			Public Const AmazonAccessKeyId As String = "YOUR_KEY"
		End Class
	End Class

	Private Shared Sub clearLists(ByVal ParamArray lists() As ListBox)
		For Each list As ListBox In lists
			list.DataSource = Nothing
		Next
	End Sub

	Private Shared Sub populateItems(ByVal parent() As ListItem, ByVal child() As ListItem, ByVal index As Integer)
		' items are passed by reference
		Dim i As Integer = 0
		Do While (i < child.Length)
			parent((index + i)) = child(i)
			i = (i + 1)
		Loop
	End Sub

	Private Function GetWishlistItems(ByVal ListId As String, ByVal Page As Integer, ByRef TotalPages As Integer, ByRef TotalItems As Integer) As ListItem()
		TotalPages = 0
		TotalItems = 0
		Dim request As ListLookupRequest = New ListLookupRequest
		request.ListId = ListId
		request.ListType = ListLookupRequestListType.WishList
		request.ListTypeSpecified = True
		request.ProductPage = Page.ToString
		request.ResponseGroup = New String() {"ListItems", "ItemAttributes"}
		' ItemAttributes gets me package size
		Dim listLookup As ListLookup = New ListLookup
		listLookup.AWSAccessKeyId = Constants.ApplicationSettings.AmazonAccessKeyId
		listLookup.Request = New ListLookupRequest() {request}

		Dim amazonPrime As AWSECommerceService = New AmazonWishList.AmazonWebServices.AWSECommerceService
		Dim response As ListLookupResponse = amazonPrime.ListLookup(listLookup)
		' populate wishlists
		If ((Not (response.Lists) Is Nothing) _
					AndAlso ((response.Lists.Length > 0) _
					AndAlso (response.Lists(0).List.Length > 0))) Then
			Dim returnedList As List = response.Lists(0).List(0)
			TotalPages = Convert.ToInt32(returnedList.TotalPages)
			TotalItems = Convert.ToInt32(returnedList.TotalItems)
			Return response.Lists(0).List(0).ListItem
		End If
		Return Nothing
	End Function

	Private Sub btnFind_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFind.Click
		' clearing info
		clearLists(lstGifts, lstWishlists)
		' sample URL that returns wishlist data
		' http://webservices.amazon.com/onca/xml?Service=AWSECommerceService&
		'AWSAccessKeyId=[Your Access Key ID Here]&Operation=ListSearch&ListType=WishList&Email=Clint@pronerd.com
		' building search object for wishlist
		Dim request As ListSearchRequest = New ListSearchRequest
		request.ListType = ListSearchRequestListType.WishList
		request.Email = txtEmail.Text
		Dim listSearcher As ListSearch = New ListSearch
		listSearcher.AWSAccessKeyId = Constants.ApplicationSettings.AmazonAccessKeyId
		listSearcher.Request = New ListSearchRequest() {request}

		Dim amazonPrime As AWSECommerceService = New AmazonWishList.AmazonWebServices.AWSECommerceService
		Dim response As ListSearchResponse = amazonPrime.ListSearch(listSearcher)
		' populate wishlists
		If (response.Lists.Length > 0) Then
			Dim returnLists() As List = response.Lists(0).List
			lstWishlists.DataSource = returnLists
			lstWishlists.DisplayMember = "ListName"
			' want to show the list name
		End If
	End Sub

	Private Sub lstWishlists_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles lstWishlists.SelectedIndexChanged
		clearLists(lstGifts)
		Dim list As List = CType(CType(sender, ListBox).SelectedItem, List)
		' man I love all that casting
		'http://
		'webservices.amazon.com/onca/xml?Service=AWSECommerceService&AWSAccessKey
		'Id=[Your Access Key ID Here]&Operation=ListLookup&ListType=WishList&ListId=1Z9OS6MSATXPQ
		Dim totalPages As Integer
		Dim totalItems As Integer
		Dim listItemsTemp() As ListItem = GetWishlistItems(list.ListId, 1, totalPages, totalItems)
		' populate wishlists
		If (totalItems > 0) Then
			Dim listItems(totalItems) As ListItem

			populateItems(listItems, listItemsTemp, 0)
			Dim ii As Integer = 2
			Do While (ii <= totalPages)
				listItemsTemp = GetWishlistItems(list.ListId, ii, totalPages, totalItems)
				Dim index As Integer = (10 * (ii - 1))
				' index is zero based, page count is 1 based, 10 items per result
				populateItems(listItems, listItemsTemp, index)
				ii = (ii + 1)
			Loop
			giftList = New ArrayList
			Dim i As Integer = 0
			Do While (i < listItems.Length - 1)
				' can't do this since it tells you if you have the item bought.
				' I found out I have 2 copies of Rome (sorry Mom!  I swear I found out on accident.)
				'if (Convert.ToInt32(listItems[i].QuantityDesired) > Convert.ToInt32(listItems[i].QuantityReceived))
				' one of my items didn't have a package list
				If (Not (listItems(i).Item.ItemAttributes.PackageDimensions) Is Nothing) Then
					Dim height As Decimal = Convert.ToDecimal(listItems(i).Item.ItemAttributes.PackageDimensions.Height.Value)
					Dim width As Decimal = Convert.ToDecimal(listItems(i).Item.ItemAttributes.PackageDimensions.Width.Value)
					Dim length As Decimal = Convert.ToDecimal(listItems(i).Item.ItemAttributes.PackageDimensions.Length.Value)
					' amazon returns can be in hundreths and other units.  This isn't perfect but I couldn't find
					' any reference to all measurements.
					If (listItems(i).Item.ItemAttributes.PackageDimensions.Height.Units.IndexOf("hundredths") > -1) Then
						height = height / 100
					End If

					If (listItems(i).Item.ItemAttributes.PackageDimensions.Width.Units.IndexOf("hundredths") > -1) Then
						width = width / 100
					End If

					If (listItems(i).Item.ItemAttributes.PackageDimensions.Length.Units.IndexOf("hundredths") > -1) Then
						length = length / 100
					End If

					giftList.Add(New ListItemsSimple(listItems(i).ListItemId, listItems(i).Item.ItemAttributes.Title, listItems(i).Item.DetailPageURL, height, width, length))
				End If
				i = (i + 1)
			Loop
			lstGifts.DataSource = giftList
			lstGifts.DisplayMember = "Title"
			' want to show the name
		End If
	End Sub

	Private Sub btnCheck_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnCheck.Click
		Dim templist As ArrayList = New ArrayList
		Dim i As Integer = 0
		Do While (i < giftList.Count)
			Dim tolerance As Decimal = numTol.Value
			Dim temp As ListItemsSimple = CType(giftList(i), ListItemsSimple)
			If ((Math.Abs((temp.Height - numHeight.Value)) < tolerance) _
			   AndAlso (((Math.Abs((temp.Length - numLength.Value)) < tolerance) _
			   AndAlso (Math.Abs((temp.Width - numWidth.Value)) < tolerance)) _
			   OrElse ((Math.Abs((temp.Width - numLength.Value)) < tolerance) _
			   AndAlso (Math.Abs((temp.Length - numWidth.Value)) < tolerance)))) Then
				templist.Add(giftList(i))
			End If
			i = (i + 1)
		Loop
		lstGifts.DataSource = templist
		lstGifts.DisplayMember = "Title"
		' want to show the list name
	End Sub

	Private Sub btnReset_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnReset.Click
		lstGifts.DataSource = giftList
	End Sub
End Class